from typing import TYPE_CHECKING, Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

if TYPE_CHECKING:
    from ..models.get_image_pages_out import GetImagePagesOut


T = TypeVar("T", bound="PagedGetImagePagesOut")


@_attrs_define
class PagedGetImagePagesOut:
    """
    Attributes:
        items (list['GetImagePagesOut']):
        count (int):
    """

    items: list["GetImagePagesOut"]
    count: int
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        items = []
        for items_item_data in self.items:
            items_item = items_item_data.to_dict()
            items.append(items_item)

        count = self.count

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "items": items,
                "count": count,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: dict[str, Any]) -> T:
        from ..models.get_image_pages_out import GetImagePagesOut

        d = src_dict.copy()
        items = []
        _items = d.pop("items")
        for items_item_data in _items:
            items_item = GetImagePagesOut.from_dict(items_item_data)

            items.append(items_item)

        count = d.pop("count")

        paged_get_image_pages_out = cls(
            items=items,
            count=count,
        )

        paged_get_image_pages_out.additional_properties = d
        return paged_get_image_pages_out

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
